/*******************************************************************************
 * FoxOnlineStatsWriteMatchmakingReport generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxOnlineStatsWriteMatchmakingReport extends ZeOnlineStatsWrite
    native;

const PROPERTY_ROOMS_ENCOUNTERED = 0x20000020;
const PROPERTY_ROOMS_PINGABLE = 0x20000021;
const PROPERTY_JOINS_ATTMEPTED = 0x20000022;
const PROPERTY_JOINS_FAILED = 0x20000023;
const PROPERTY_NUM_SEARCHES = 0x20000024;
const PROPERTY_TOTAL_SEARCH_TIME = 0x20000025;
const PROPERTY_AVG_ROOM_PING = 0x20000025;
const PROPERTY_AVG_ROOM_POPULATION = 0x20000026;
const PROPERTY_AVG_ROOM_QUALITY = 0x20000027;
const PROPERTY_JOINED_MATCH_QUALITY = 0x20000028;
const PROPERTY_JOINED_MATCH_PING = 0x20000029;
const PROPERTY_JOINED_MATCH_POPULATION = 0x20000030;
const PROPERTY_SELF_IS_HOSTABLE = 0x20000030;
const PROPERTY_SELF_RESOLUTION = 0x20000031;
const PROPERTY_MATCHMAKING_NOTE = 0x20000032;
const PROPERTY_PLAYLIST = 0X20000033;
const PROPERTY_PLAYLIST_INDEXCURR = 0X20000034;
const PROPERTY_PLAYLIST_INDEXMAX = 0X20000035;

enum EMatchMakingResolution
{
    MMR_NONE,
    MMR_CancelledSearch,
    MMR_CancelledJoining,
    MMR_CreateGame,
    MMR_JoinedGame,
    MMR_FailedSearch,
    MMR_FailedCreate,
    MMR_FailedCreateBadPlaylist,
    MMR_FailedNonDescript,
    MMR_CancelledAtCleanUp,
    MMR_ERROR,
    MMR_MAX
};

var transient float CurrentStartTime;
var transient float AvgQualityAccumulator;
var transient int AvgPingAccumulator;
var transient int AvgPopulationAccumulator;

function SetPlaylistName(string Playlist)
{
    SetStringStat(536870963, Playlist);
    //return;    
}

function SetPlaylistIndex(int Index)
{
    SetIntStat(536870964, Index);
    //return;    
}

function SetPlaylistIndexMax(int IndexMax)
{
    SetIntStat(536870965, IndexMax);
    //return;    
}

function IncrementJoinAttempts()
{
    IncrementIntStat(536870946);
    //return;    
}

function IncrementJoinFailures()
{
    IncrementIntStat(536870947);
    //return;    
}

function IncrementSearchCount()
{
    IncrementIntStat(536870948);
    //return;    
}

function SetJoiningMatchStats(int Ping, int Population, float Quality)
{
    SetIntStat(536870953, Ping);
    SetIntStat(536870960, Population);
    SetFloatStat(536870952, Quality);
    //return;    
}

function SetResolution(int Resolution)
{
    SetIntStat(536870961, Resolution);
    //return;    
}

function UpdateResolution(int Resolution)
{
    local int CurrentResolution;

    CurrentResolution = GetIntStat(536870961);
    // End:0x28
    if(CurrentResolution == 0)
    {
    }
    SetResolution(Resolution);
    //return;    
}

function SetNote(string Note)
{
    SetStringStat(536870962, Note);
    //return;    
}

function SetHostable(bool bHostable)
{
    SetIntStat(536870960, ((bHostable == true) ? 1 : 0));
    //return;    
}

function SetSearchStartTime(float StartTime)
{
    CurrentStartTime = StartTime;
    //return;    
}

function SetSearchEndTime(float EndTime)
{
    SetFloatStat(536870949, EndTime - CurrentStartTime);
    //return;    
}

function AddForAverage(int Ping, int Population, float Quality)
{
    AvgPingAccumulator += Ping;
    AvgPopulationAccumulator += Population;
    AvgQualityAccumulator += Quality;
    IncrementIntStat(536870945);
    //return;    
}

function LogFoundRooms(int RoomCount)
{
    IncrementIntStat(536870944, RoomCount);
    //return;    
}

function string PrintLog()
{
    local int NumPingable;

    NumPingable = GetIntStat(536870945);
    NumPingable = ((NumPingable == 0) ? -1 : NumPingable);
    SetIntStat(536870949, AvgPingAccumulator / NumPingable);
    SetIntStat(536870950, AvgPopulationAccumulator / NumPingable);
    SetIntStat(536870951, int(AvgQualityAccumulator / float(NumPingable)));
    return super.PrintLog();
    //return ReturnValue;    
}

defaultproperties
{
    Properties=/* Array type was not detected. */
    StatsGroupName=matchmaking
    StatNameToStatIdMapping=/* Array type was not detected. */
}